<?php
namespace Claromentis\People;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] = (@$GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"] ?: array()) + array("_88aa4158" . "bbda1ad77" . "d138780ea" . "68e38b" => base64_decode("U0VMRUNUIGlkLCBpc19wcmltYXJ5IEZST00gb3JnX2NoYXJ0IFdIRVJF" . "IGJvc3NfaWQ9aW50OnVpZA=="), "_2f700090654ea43a4fec1f8ca5084" . "d38" => base64_decode("REVMRVRFIEZST00gb3JnX2NoYXJ0IFdIRVJFIGJvc3N" . "faWQ9aW50OnVpZA=="), "_e024889" . "92f8ce86" . "b71d9f32" . "b29fe215" . "c" => base64_decode("SU5TRVJUIElOVE8gb3JnX2NoYXJ0IChpZCwgYm9zc19pZC" . "wgaXNfcHJpbWFyeSkgVkFMVUVTIChpbnQ6dWlkLCBpbnQ6" . "bWFuYWdlcl9pZCwgMSk="), "_736432b3f9e1c" . "d2ec77cd6f2ba0" . "c3bdb" => base64_decode("U0VMRUNUIGJvc3NfaWQgRlJPTSBvcmdfY2hhcnQgV0" . "hFUkUgaWQ9aW50OnVpZCBBTkQgYm9zc19pZDw+aW50" . "OnVpZCBPUkRFUiBCWSBpc19wcmltYXJ5"), "_62d701c3c53404f06345eb" . "35720a47b4" => base64_decode("aXNfbnVtZ" . "XJpYw=="), "_680cc2b8" . "220e94c8c" . "32b8bc7c6" . "5519b4" => base64_decode("aXNfaW" . "50"), "_98966bfaaccbe" . "b4658a87a97e8f" . "afb11" => base64_decode("REVMRVRFIEZST00gb3JnX2No" . "YXJ0IFdIRVJFIGlkPWludDp1" . "aWQ="), "_7f628626dd1d55c71b1fc0932" . "ffd1d2c" => base64_decode("aXN" . "fYX" . "JyY" . "Xk="));
use Claromentis\Core\DAL\Interfaces\DbInterface;







class UsersHierarchyService
{
    
    
    
    
    protected $db;
    public function __construct(DbInterface $db)
    {
        $this->db = $db;
    }
    
    
    
    
    
    
    
    
    public function SetManager($user_id, $_b324f64f5346fe6cd20483e208d94430) : bool
    {
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_62d701c3c53404f0" . "6345eb35720a47b4"]($user_id) || !$user_id) {
            return false;
        }
        
        
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_98966bfaaccbeb4658a8" . "7a97e8fafb11"], $user_id);
        if ($_b324f64f5346fe6cd20483e208d94430 === null) {
            return true;
        }
        if (!$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_680cc2b82" . "20e94c8c32" . "b8bc7c6551" . "9b4"]($_b324f64f5346fe6cd20483e208d94430)) {
            return false;
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_e02488992f8" . "ce86b71d9f32" . "b29fe215c"], $user_id, $_b324f64f5346fe6cd20483e208d94430);
        return true;
    }
    
    
    
    
    
    
    
    public function SetSubordinates($user_id, $_9b25bd1f846ab3177a43069b54248349)
    {
        
        
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_2f700090654ea43a4fec" . "1f8ca5084d38"], $user_id);
        
        
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_7f628626dd1d55c71b1fc0932ffd1d" . "2c"]($_9b25bd1f846ab3177a43069b54248349)) {
            return false;
        }
        
        
        foreach ($_9b25bd1f846ab3177a43069b54248349 as $_f19d55a3cc79997bcb33f250cc2ee482) {
            if (!$this->SetManager($_f19d55a3cc79997bcb33f250cc2ee482, $user_id)) {
                return false;
            }
        }
        return true;
    }
    
    
    
    
    
    
    
    public function GetManager($user_id)
    {
        list($_b324f64f5346fe6cd20483e208d94430) = $this->db->query_row($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_736432b3f9e1" . "cd2ec77cd6f2b" . "a0c3bdb"], $user_id, $user_id);
        return $_b324f64f5346fe6cd20483e208d94430 ?? 0;
    }
    
    
    
    
    
    
    
    public function GetSubordinates($user_id)
    {
        $_189840d11056515e52402d1412a0b6e4 = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_88aa4158bbd" . "a1ad77d13878" . "0ea68e38b"], $user_id);
        $_5bbedf94f4628faff30d9e300695d342 = array();
        while ($row = $_189840d11056515e52402d1412a0b6e4->fetchRow()) {
            if (!$row[1] && self::GetManager($row[0]) != $user_id) {
                continue;
            }
            $_5bbedf94f4628faff30d9e300695d342[] = $row[0];
        }
        return $_5bbedf94f4628faff30d9e300695d342;
    }
}